unit uTNTest;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, ExtCtrls, uTn3270E, u3270Fields, uHSTNConsts,
  uHSTelnet;
                                   
type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    btnPF1: TButton;
    btnPF2: TButton;
    btnPF3: TButton;
    btnPF4: TButton;
    btnPF5: TButton;
    btnPF6: TButton;
    btnPF7: TButton;
    btnPF8: TButton;
    btnPF9: TButton;
    btnPF10: TButton;
    btnPF11: TButton;
    btnPF12: TButton;
    btnPF13: TButton;
    btnPF14: TButton;
    btnPF15: TButton;
    btnPF16: TButton;
    btnPF17: TButton;
    btnPF18: TButton;
    btnPF19: TButton;
    btnPF20: TButton;  
    btnPF21: TButton;
    btnPF22: TButton;
    btnPF23: TButton;
    btnPF24: TButton;
    btnEnter: TButton;
    StatusBar: TStatusBar;
    cmbHosts: TComboBox;
    Label1: TLabel;
    btnConnect: TButton;
    btnDisconnect: TButton;
    FTn: TTn3270E;
    Edit1: TEdit;
    Label2: TLabel;
    btnPA2: TButton;
    btnPA1: TButton;
    btnATTN: TButton;
    btnCLEAR: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDestroy(Sender: TObject);
    procedure btnConnectClick(Sender: TObject);
    procedure btnDisconnectClick(Sender: TObject);
    procedure btnAidKeyClick(Sender: TObject);
    
    procedure TnOnConnect(Sender: TObject);
    procedure TnOnConnectionFail(Sender: TObject);
    procedure TnOnDisconnect(Sender: TObject);
    procedure TnOnSessionState(Sender: TObject);
    procedure TnOnScreenChange(Sender: TObject);
    procedure TnOnSystemLock(Sender: TObject);
    procedure TnOnSystemUnLock(Sender: TObject);
  private
    { Private declarations }
    procedure RefreshStates;
    procedure ClearPanel;
  public
    { Public declarations }
(*
    FTn: TTn3270E;
    procedure TnOnConnect(Sender: TObject);
    procedure TnOnConnectionFail(Sender: TObject);
    procedure TnOnDisconnect(Sender: TObject);
    procedure TnOnSessionState(Sender: TObject);
    procedure TnOnScreenChange(Sender: TObject);
    procedure TnOnSystemLock(Sender: TObject);
    procedure TnOnSystemUnLock(Sender: TObject);
*)
    procedure FldChange(Sender: TObject);
    procedure FldExit(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

const
  STD_HOSTS_FILE: String = 'HOSTS.TXT';

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  { Create test component }
(*
  FTn := TTn3270E.Create(Self);
  FTn.LoggingLevel       := 9;
  FTn.OnConnect          := TnOnConnect;
  FTn.OnConnectionFail   := TnOnConnectionFail;
  FTn.OnDisconnect       := TnOnDisconnect;
  FTn.OnSessionState     := TnOnSessionState;
  FTn.OnScreenChange     := TnOnScreenChange;
  FTn.OnSystemLock       := TnOnSystemLock;
  FTn.OnSystemUnLock     := TnOnSystemUnLock;
*)
  { Refresh states }
  RefreshStates;
  { Load hosts list and set the first item to default }
  STD_HOSTS_FILE := ExtractFilePath(Application.ExeName) + STD_HOSTS_FILE;
  if FileExists(STD_HOSTS_FILE) then
    cmbHosts.Items.LoadFromFile(STD_HOSTS_FILE);
  if cmbHosts.Items.Count > 0 then
    cmbHosts.ItemIndex := 0;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //FTn.Free;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  {}
end;

procedure TForm1.RefreshStates;
begin
  btnConnect.Enabled    := not FTn.IsConnected;
  btnDisconnect.Enabled := FTn.IsConnected;
end;

procedure TForm1.btnConnectClick(Sender: TObject);
begin
  FTn.Host := cmbHosts.Text;
  FTn.ConversionTable := Edit1.Text;
  FTn.Connect;
end;

procedure TForm1.ClearPanel;
begin
  while Panel2.ControlCount > 0 do Panel2.Controls[0].Free;
end;

procedure TForm1.btnDisconnectClick(Sender: TObject);
begin
  ClearPanel;
  FTn.Disconnect;
end;

procedure TForm1.TnOnConnect(Sender: TObject);
begin
  RefreshStates;
  TnOnSessionState(Sender);
end;

procedure TForm1.TnOnConnectionFail(Sender: TObject);
begin
  RefreshStates;
  StatusBar.Panels[0].Text := 'CONNECTION FAILED';
end;

procedure TForm1.TnOnDisconnect(Sender: TObject);
begin
  RefreshStates;
  StatusBar.Panels[0].Text := 'DISCONNECTED';
end;

procedure TForm1.TnOnSystemLock(Sender: TObject);
begin
  StatusBar.Panels[1].Text := 'X-WAIT';
end;

procedure TForm1.TnOnSystemUnLock(Sender: TObject);
begin
  StatusBar.Panels[1].Text := '';
end;

procedure TForm1.TnOnScreenChange(Sender: TObject);
var
  i: Integer;
  ctrl: TControl;
  ColWidth : Integer;
  RowHeight : Integer;
  Field : T3270Field;
begin
  ColWidth:=8;
  RowHeight:=16;
  Ctrl:=nil;

  StatusBar.Panels[1].Text := 'X( )';
  Panel2.Hide;
  try
    ClearPanel;
    for i:=0 to FTn.AllFields.Count-1 do begin
      Field:=(FTn.AllFields[i] as T3270Field);
      if Field.Editable then begin
        Ctrl := TEdit.Create(Self);
        (Ctrl as TEdit).AutoSize:=False;
        (Ctrl as TEdit).BorderStyle:=bsNone;
        (Ctrl as TEdit).Font.Assign(Panel2.Font);
        (Ctrl as TEdit).Font.Color := Field.Color;
        (Ctrl as TEdit).Color := Panel2.Color;
        (Ctrl as TEdit).MaxLength := Field.Len;
        (Ctrl as TEdit).OnChange := FldChange;
        (Ctrl as TEdit).OnExit := FldExit;
        if not Field.Visible then
          (Ctrl as TEdit).PasswordChar:='*';
      end else if Field.Visible then begin
        Ctrl := TLabel.Create(Self);
        (Ctrl as TLabel).Font.Assign(Panel2.Font);
        (Ctrl as TLabel).ShowAccelChar := False;
        if Field.Reverse Then begin
          (Ctrl as TLabel).Color := Field.Color;
          (Ctrl as TLabel).Font.Color := clWhite;
        end else
          (Ctrl as TLabel).Font.Color := Field.Color;
      end else continue;

      Panel2.InsertControl(Ctrl);
      with Ctrl do begin
        Name   := Field.Name;
        Left   := 8 + (ColWidth * (Field.Col-1));
        Top    := 8 + (RowHeight+1)*(Field.Row-1);
        Width  := ColWidth * Field.Len;
        Height := RowHeight;
        SetTextBuf(PChar(Field.Data));
      end;
    end;
  finally
    Panel2.Show;
    StatusBar.Panels[1].Text := '';
  end;
end;

procedure TForm1.TnOnSessionState(Sender: TObject);
begin
  case FTn.SessionState of
     ssNone   : StatusBar.Panels[0].Text := 'CONNECTED';
     ssSscpLu : StatusBar.Panels[0].Text := 'SSCP-LU';
     ssLuLu   : StatusBar.Panels[0].Text := 'LU-LU';
  end;
end;

procedure TForm1.FldChange(Sender: TObject);
begin
  (Sender as TEdit).Tag := 1;
end;

procedure TForm1.FldExit(Sender: TObject);
var
  i: Integer;
  Field: T3270Field;
begin
  for i:=0 to FTn.EditFields.Count-1 do
    if FTn.EditFields[i].Name = TEdit(Sender).Name then begin
      if (Sender as TEdit).Tag = 1 then begin
        Field := T3270Field(FTn.EditFields[i]);
        Field.Data := TEdit(Sender).Text;
        (Sender as TEdit).Tag := 0;
        FTn.EditFields.CursorPos := Field.Pos + Length(Trim(Field.Data));
        break;
      end;
    end;
end;

procedure TForm1.btnAidKeyClick(Sender: TObject);
begin
  if Sender=btnPF1 then FTn.AidKey := akPF1;
  if Sender=btnPF2 then FTn.AidKey := akPF2;
  if Sender=btnPF3 then FTn.AidKey := akPF3;
  if Sender=btnPF4 then FTn.AidKey := akPF4;
  if Sender=btnPF5 then FTn.AidKey := akPF5;
  if Sender=btnPF6 then FTn.AidKey := akPF6;
  if Sender=btnPF7 then FTn.AidKey := akPF7;
  if Sender=btnPF8 then FTn.AidKey := akPF8;
  if Sender=btnPF9 then FTn.AidKey := akPF9;
  if Sender=btnPF10 then FTn.AidKey := akPF10;
  if Sender=btnPF11 then FTn.AidKey := akPF11;
  if Sender=btnPF12 then FTn.AidKey := akPF12;
  if Sender=btnPF13 then FTn.AidKey := akPF13;
  if Sender=btnPF14 then FTn.AidKey := akPF14;
  if Sender=btnPF15 then FTn.AidKey := akPF15;
  if Sender=btnPF16 then FTn.AidKey := akPF16;
  if Sender=btnPF17 then FTn.AidKey := akPF17;
  if Sender=btnPF18 then FTn.AidKey := akPF18;
  if Sender=btnPF19 then FTn.AidKey := akPF19;
  if Sender=btnPF20 then FTn.AidKey := akPF20;
  if Sender=btnPF21 then FTn.AidKey := akPF21;
  if Sender=btnPF22 then FTn.AidKey := akPF22;
  if Sender=btnPF23 then FTn.AidKey := akPF23;
  if Sender=btnPF24 then FTn.AidKey := akPF24;
  if Sender=btnPA1 then FTn.AidKey := akPA1;
  if Sender=btnPA2 then FTn.AidKey := akPA2;
  if Sender=btnATTN then FTn.AidKey := akAttn;
  if Sender=btnClear then FTn.AidKey := akClear;
  if Sender=btnEnter then FTn.AidKey := akEnter;
end;
       
end.

